--------------------------
-- SyMerchant.lua
-- Author: Sayoc
-- Date: 17.04.07
--------------------------

local UseGuildRepair = true 			-- 是否优先使用公会维修

------------- Sell Junk ----------------

local function SellJunk()
	if not MerchantFrame:IsVisible() then return 0 end
	
	totalPrice = 0	
	
	for myBags = 0,4 do
		for bagSlots = 1, GetContainerNumSlots(myBags) do
			local itemLink = GetContainerItemLink(myBags, bagSlots)
			if itemLink then
				_, _, itemRarity, _, _, _, _, _, _, _, itemSellPrice = GetItemInfo(itemLink)
				_, itemCount = GetContainerItemInfo(myBags, bagSlots)
				if itemRarity == 0 and itemSellPrice ~= 0 then
					totalPrice = totalPrice + (itemSellPrice * itemCount)
					UseContainerItem(myBags, bagSlots)
				end
			end
		end
	end
	
	if totalPrice ~= 0 then
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900--|r 自动物品卖出： "..GetCoinTextureString(totalPrice), 255, 255, 255)
	end

end

------------- Auto Repair ----------------

local guildBankRepaired = false

local function RepairItems()
	if not MerchantFrame:IsVisible() or not CanMerchantRepair()  then return 0 end	
	
	local repairAllCost, canRepair = GetRepairAllCost()	
	
	if (canRepair and repairAllCost > 0 ) then
	
		if UseGuildRepair and IsInGuild() and CanGuildBankRepair() and (GetGuildBankWithdrawMoney() >= repairAllCost) then
			guildBankRepaired = true
			RepairAllItems(true)	
		end
		
		if (GetMoney() >= repairAllCost) then
			RepairAllItems()			
		else
			return 0
		end		
		
		PlaySound("7994")
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900--|r 自动装备维修，费用支出："..GetCoinTextureString(repairAllCost), 255, 255, 255)
	end

end

------------- Event ------------------------

local f = CreateFrame("Frame")
f:Hide()
f:RegisterEvent("MERCHANT_SHOW")
f:RegisterEvent("GUILDBANK_UPDATE_WITHDRAWMONEY")
f:RegisterEvent("MERCHANT_CLOSED")

f:SetScript("OnEvent", function(self, event, ...)
	if event == "MERCHANT_SHOW" then
		SellJunk() 
		RepairItems()
	elseif event == "GUILDBANK_UPDATE_WITHDRAWMONEY" then
		if guildBankRepaired then 
			local gbwm = GetGuildBankWithdrawMoney() 
			if IsGuildLeader() or gbwm > 100000000 then 
				DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900--|r 本次使用公会维修。", 255, 255, 255)
			else				
				DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900--|r 本次使用公会维修， 剩余可用公费：".. GetCoinTextureString(gbwm), 255, 255, 255)
			end
			guildBankRepaired = false
		end
	elseif event == "MERCHANT_CLOSED" then
		guildBankRepaired = false
	end			
end)